function th5attput()

fprintf ( 1, '\nStarting H5ATTPUT tests.\n\n' );

test_001('foo.h5');    % write int8 precision attribute to a group
test_002('foo.h5');    % write uint8 precision attribute to a group
test_003('foo.h5');    % write int16 attribute to a group
test_004('foo.h5');    % write uint16 attribute to a group
test_005('foo.h5');    % write int32 attribute to a group
test_006('foo.h5');    % write uint32 attribute to a group
test_007('foo.h5');    % write int64 attribute to a group
test_008('foo.h5');    % write uint64 attribute to a group
test_009('foo.h5');    % write char attribute to a group

fprintf ( 1, '\nAll H5ATTPUT tests succeeded.\n\n' );
delete('foo.h5');

%--------------------------------------------------------------------------
function create_testfile(hfile)

create_plist = H5P.create('H5P_FILE_CREATE');
file_id = H5F.create(hfile, 'H5F_ACC_TRUNC',create_plist , 'H5P_DEFAULT');
H5F.close(file_id);
H5P.close(create_plist);

%--------------------------------------------------------------------------
function test_001(hfile)
% Write a signed byte attribute
%

create_testfile(hfile);

expData = int8([3 5]');
h5attput(hfile,'/', 'attr1', expData);
actData = h5attget(hfile,'/','attr1');

if ~isequal(actData,expData) && isa(actData,'int8')
	error ( 'failed to verify int8 precision attribute creation');
end

fprintf ( 1, 'Creation of an int8 attribute onto a group succeeded.\n' );


%--------------------------------------------------------------------------
function test_002(hfile)
% Write an unsigned byte attribute
%

create_testfile(hfile);

expData = uint8([3 5]');
h5attput(hfile,'/', 'attr1', expData);
actData = h5attget(hfile,'/','attr1');

if ~isequal(actData,expData) && isa(actData,'uint8')
	error ( 'failed to verify int8 precision attribute creation');
end

fprintf ( 1, 'Creation of a uint8 attribute onto a group succeeded.\n' );


%--------------------------------------------------------------------------
function test_003(hfile)
% Write int16 attribute
%

create_testfile(hfile);

expData = int16([3 5]');
h5attput(hfile,'/', 'attr1', expData);
actData = h5attget(hfile,'/','attr1');

if ~isequal(actData,expData) && isa(actData,'int16')
	error ( 'failed to verify int16 precision attribute creation');
end

fprintf ( 1, 'Creation of an int16 attribute onto a group succeeded.\n' );


%--------------------------------------------------------------------------
function test_004(hfile)
% Write uint16 attribute
%

create_testfile(hfile);

expData = uint16([3 5]');
h5attput(hfile,'/', 'attr1', expData);
actData = h5attget(hfile,'/','attr1');

if ~isequal(actData,expData) && isa(actData,'uint16')
	error ( 'failed to verify int16 precision attribute creation');
end

fprintf ( 1, 'Creation of a uint16 attribute onto a group succeeded.\n' );


%--------------------------------------------------------------------------
function test_005(hfile)
% Write int32 attribute
%

create_testfile(hfile);

expData = int32([3 5]');
h5attput(hfile,'/', 'attr1', expData);
actData = h5attget(hfile,'/','attr1');

if ~isequal(actData,expData) && isa(actData,'int32')
	error ( 'failed to verify int32 precision attribute creation');
end

fprintf ( 1, 'Creation of an int32 attribute onto a group succeeded.\n' );


%--------------------------------------------------------------------------
function test_006(hfile)
% Write uint32 attribute
%

create_testfile(hfile);

expData = uint32([3 5]');
h5attput(hfile,'/', 'attr1', expData);
actData = h5attget(hfile,'/','attr1');

if ~isequal(actData,expData) && isa(actData,'uint32')
	error ( 'failed to verify int32 precision attribute creation');
end

fprintf ( 1, 'Creation of a uint32 attribute onto a group succeeded.\n' );


%--------------------------------------------------------------------------
function test_007(hfile)
% Write int64 attribute
%

create_testfile(hfile);

expData = int64([3 5]');
h5attput(hfile,'/', 'attr1', expData);
actData = h5attget(hfile,'/','attr1');

if ~isequal(actData,expData) && isa(actData,'int64')
	error ( 'failed to verify int64 precision attribute creation');
end

fprintf ( 1, 'Creation of an int64 attribute onto a group succeeded.\n' );

%--------------------------------------------------------------------------
function test_008(hfile)
% Write uint64 attribute
%

create_testfile(hfile);

expData = uint64([3 5]');
h5attput(hfile,'/', 'attr1', expData);
actData = h5attget(hfile,'/','attr1');

if ~isequal(actData,expData) && isa(actData,'uint64')
	error ( 'failed to verify int64 precision attribute creation');
end

fprintf ( 1, 'Creation of a uint64 attribute onto a group succeeded.\n' );


%--------------------------------------------------------------------------
function test_009(hfile)
% Write char attribute
%

create_testfile(hfile);

expData = 'abcd';
h5attput(hfile,'/', 'attr1', expData);
actData = h5attget(hfile,'/','attr1');

if ~isequal(actData,expData) && isa(actData,'char')
	error ( 'failed to verify char attribute creation');
end

fprintf ( 1, 'Creation of a uint64 attribute onto a group succeeded.\n' );



